
#include <math.h>
#include <gnome.h>
#include "filedirs.h"
#include <gmonsters/gmonsters.h>

void gm_specedit_select(GtkWidget *, guint, guint);
void gm_specedit_name_change();
void gm_specedit_desc_change();
void gm_specedit_quit();
void gm_specedit_save();
void gm_specedit_hp_up();
void gm_specedit_hp_down();
void gm_specedit_str_up();
void gm_specedit_str_down();
void gm_specedit_def_up();
void gm_specedit_def_down();
void gm_specedit_spd_up();
void gm_specedit_spd_down();
void gm_specedit_int_up();
void gm_specedit_int_down();
void gm_specedit_stone();
void gm_specedit_flying();
void gm_specedit_electric();
void gm_specedit_water();
void gm_specedit_fire();
void gm_specedit_poison();
void gm_specedit_insect();
void gm_specedit_plant();
void gm_specedit_fighting();
void gm_specedit_psychic();
void gm_specedit_fungus();
void gm_specedit_nocturnal();
void gm_specedit_cybernetic();
void gm_specedit_ice();
void gm_specedit_energy();
void gm_specedit_ghost();
void gm_specedit_plains();
void gm_specedit_forest();
void gm_specedit_caves();
void gm_specedit_mountains();
void gm_specedit_oceans();
void gm_specedit_rivers();
void gm_specedit_new();
void gm_specedit_delete();
void gm_specedit_really_delete(gint, gpointer);
void gm_specedit_ability_select(GtkWidget *, guint, guint);
void gm_specedit_ability_add();
void gm_specedit_ability_remove();

guint selected = 0;
guint aselected = 0;
guint snum = 0;
gchar *infostr = 0;
GtkWidget *slist;
GtkWidget *name;
GtkWidget *desc;
GtkWidget *hplabel;
GtkWidget *hpup;
GtkWidget *hpdown;
GtkWidget *strlabel;
GtkWidget *strup;
GtkWidget *strdown;
GtkWidget *deflabel;
GtkWidget *defup;
GtkWidget *defdown;
GtkWidget *spdlabel;
GtkWidget *spdup;
GtkWidget *spddown;
GtkWidget *intlabel;
GtkWidget *intup;
GtkWidget *intdown;
GtkWidget *window;
GtkWidget *alist;
GtkWidget *stoneb;
GtkWidget *flyingb;
GtkWidget *electricb;
GtkWidget *waterb;
GtkWidget *fireb;
GtkWidget *poisonb;
GtkWidget *insectb;
GtkWidget *plantb;
GtkWidget *fightingb;
GtkWidget *psychicb;
GtkWidget *fungusb;
GtkWidget *nocturnalb;
GtkWidget *cyberneticb;
GtkWidget *iceb;
GtkWidget *energyb;
GtkWidget *ghostb;
GtkWidget *plainsb;
GtkWidget *forestb;
GtkWidget *cavesb;
GtkWidget *mountainsb;
GtkWidget *oceansb;
GtkWidget *riversb;
GtkWidget *news;
GtkWidget *deletes;
GtkWidget *alevel;
GtkWidget *aability;
GtkWidget *aadd;
GtkWidget *aremove;

int
main(int argc, char **argv)
{
	gchar *tmp;
	gchar *titles[1] = { "Species" };
	gchar *atitles[2] = { "Level", "Ability" };
	GtkWidget *packer;
	GtkWidget *cancel;
	GtkWidget *save;
	GtkWidget *ok;
	GtkWidget *frame;
	GtkWidget *aframe;
	GtkWidget *fhbox;
	GtkWidget *fvbox;
	GtkWidget *avbox;
	GtkWidget *ahbox;
	GtkWidget *ashbox;
	GtkWidget *abhbox;
	GtkWidget *svbox;
	GtkWidget *shbox;
	GtkWidget *bhbox;
	GtkWidget *hbox;
	GtkWidget *hphbox;
	GtkWidget *strhbox;
	GtkWidget *defhbox;
	GtkWidget *spdhbox;
	GtkWidget *inthbox;
	GtkWidget *typebox;
	GtkWidget *typebox2;
	GtkWidget *areabox;
	GtkWidget *slscr;
	GtkWidget *alscr;
	guint a;
	gnome_init("Gmonsters", "0.0.1", argc, argv);
	gm_init();
	snum = gm_species_list_length();
	window = gnome_app_new("Gmonsters", "GMonsters: Species Editor");
	packer = gtk_packer_new();
	hbox = gtk_hbox_new(0, 0);
	cancel = gnome_stock_button(GNOME_STOCK_BUTTON_CANCEL);
	save = gnome_stock_button(GNOME_STOCK_BUTTON_APPLY);
	ok = gnome_stock_button(GNOME_STOCK_BUTTON_OK);
	news = gnome_pixmap_button(gnome_stock_pixmap_widget(window, GNOME_STOCK_PIXMAP_ADD), "New");
	deletes = gnome_pixmap_button(gnome_stock_pixmap_widget(window, GNOME_STOCK_PIXMAP_REMOVE), "Delete");
	gtk_widget_set_sensitive(deletes, FALSE);
	slist = gtk_clist_new_with_titles(1, titles);
	gtk_widget_set_usize(slist, 150, 1);
	for (a = 0; a < gm_species_list_length(); a++) {
		gchar *names[1] = { (gm_species_get_list() + a)->name };
		guint b;
		b = gtk_clist_append(GTK_CLIST(slist), names);
		gtk_clist_set_row_data(GTK_CLIST(slist), b, gm_species_get_list() + a);
	}
	gtk_clist_set_reorderable(GTK_CLIST(slist), TRUE);
	slscr = gtk_vscrollbar_new(NULL);
	gtk_clist_set_vadjustment(GTK_CLIST(slist), gtk_range_get_adjustment(GTK_RANGE(slscr)));
	frame = gtk_frame_new("Statistics");
	fhbox = gtk_hbox_new(FALSE, 0);
	fvbox = gtk_vbox_new(FALSE, 0);
	svbox = gtk_vbox_new(FALSE, 0);
	shbox = gtk_hbox_new(FALSE, 0);
	bhbox = gtk_hbox_new(FALSE, 0);
	name = gtk_entry_new();
	desc = gtk_entry_new();
	gtk_widget_set_sensitive(name, FALSE);
	gtk_widget_set_sensitive(desc, FALSE);
	hphbox = gtk_hbox_new(FALSE, 0);
	hplabel = gtk_label_new("Health:");
	hpup = gnome_stock_button(GNOME_STOCK_BUTTON_UP);
	hpdown = gnome_stock_button(GNOME_STOCK_BUTTON_DOWN);
	strhbox = gtk_hbox_new(FALSE, 0);
	strlabel = gtk_label_new("Strength:");
	strup = gnome_stock_button(GNOME_STOCK_BUTTON_UP);
	strdown = gnome_stock_button(GNOME_STOCK_BUTTON_DOWN);
	defhbox = gtk_hbox_new(FALSE, 0);
	deflabel = gtk_label_new("Defense:");
	defup = gnome_stock_button(GNOME_STOCK_BUTTON_UP);
	defdown = gnome_stock_button(GNOME_STOCK_BUTTON_DOWN);
	spdhbox = gtk_hbox_new(FALSE, 0);
	spdlabel = gtk_label_new("Speed:");
	spdup = gnome_stock_button(GNOME_STOCK_BUTTON_UP);
	spddown = gnome_stock_button(GNOME_STOCK_BUTTON_DOWN);
	inthbox = gtk_hbox_new(FALSE, 0);
	intlabel = gtk_label_new("Intelligence:");
	intup = gnome_stock_button(GNOME_STOCK_BUTTON_UP);
	intdown = gnome_stock_button(GNOME_STOCK_BUTTON_DOWN);
	gtk_widget_set_sensitive(hpup, FALSE);
	gtk_widget_set_sensitive(hpdown, FALSE);
	gtk_widget_set_sensitive(strup, FALSE);
	gtk_widget_set_sensitive(strdown, FALSE);
	gtk_widget_set_sensitive(defup, FALSE);
	gtk_widget_set_sensitive(defdown, FALSE);
	gtk_widget_set_sensitive(spdup, FALSE);
	gtk_widget_set_sensitive(spddown, FALSE);
	gtk_widget_set_sensitive(intup, FALSE);
	gtk_widget_set_sensitive(intdown, FALSE);
	typebox = gtk_hbox_new(TRUE, 0);
	typebox2 = gtk_hbox_new(TRUE, 0);
	stoneb = gtk_toggle_button_new();
	tmp = gm_pixmap_file("gm-stone.xpm");
	gtk_container_add(GTK_CONTAINER(stoneb), gnome_pixmap_new_from_file(tmp));
	free(tmp);
	gtk_box_pack_start(GTK_BOX(typebox), stoneb, TRUE, TRUE, 0);
	flyingb = gtk_toggle_button_new();
	tmp = gm_pixmap_file("gm-flying.xpm");
	gtk_container_add(GTK_CONTAINER(flyingb), gnome_pixmap_new_from_file(tmp));
	free(tmp);
	gtk_box_pack_start(GTK_BOX(typebox), flyingb, TRUE, TRUE, 0);
	electricb = gtk_toggle_button_new();
	tmp = gm_pixmap_file("gm-electric.xpm");
	gtk_container_add(GTK_CONTAINER(electricb), gnome_pixmap_new_from_file(tmp));
	free(tmp);
	gtk_box_pack_start(GTK_BOX(typebox), electricb, TRUE, TRUE, 0);
	waterb = gtk_toggle_button_new();
	tmp = gm_pixmap_file("gm-water.xpm");
	gtk_container_add(GTK_CONTAINER(waterb), gnome_pixmap_new_from_file(tmp));
	free(tmp);
	gtk_box_pack_start(GTK_BOX(typebox), waterb, TRUE, TRUE, 0);
	fireb = gtk_toggle_button_new();
	tmp = gm_pixmap_file("gm-fire.xpm");
	gtk_container_add(GTK_CONTAINER(fireb), gnome_pixmap_new_from_file(tmp));
	free(tmp);
	gtk_box_pack_start(GTK_BOX(typebox), fireb, TRUE, TRUE, 0);
	poisonb = gtk_toggle_button_new();
	tmp = gm_pixmap_file("gm-poison.xpm");
	gtk_container_add(GTK_CONTAINER(poisonb), gnome_pixmap_new_from_file(tmp));
	free(tmp);
	gtk_box_pack_start(GTK_BOX(typebox), poisonb, TRUE, TRUE, 0);
	insectb = gtk_toggle_button_new();
	tmp = gm_pixmap_file("gm-insect.xpm");
	gtk_container_add(GTK_CONTAINER(insectb), gnome_pixmap_new_from_file(tmp));
	free(tmp);
	gtk_box_pack_start(GTK_BOX(typebox), insectb, TRUE, TRUE, 0);
	plantb = gtk_toggle_button_new();
	tmp = gm_pixmap_file("gm-plant.xpm");
	gtk_container_add(GTK_CONTAINER(plantb), gnome_pixmap_new_from_file(tmp));
	free(tmp);
	gtk_box_pack_start(GTK_BOX(typebox), plantb, TRUE, TRUE, 0);
	fightingb = gtk_toggle_button_new();
	tmp = gm_pixmap_file("gm-fighting.xpm");
	gtk_container_add(GTK_CONTAINER(fightingb), gnome_pixmap_new_from_file(tmp));
	free(tmp);
	gtk_box_pack_start(GTK_BOX(typebox), fightingb, TRUE, TRUE, 0);
	psychicb = gtk_toggle_button_new();
	tmp = gm_pixmap_file("gm-psychic.xpm");
	gtk_container_add(GTK_CONTAINER(psychicb), gnome_pixmap_new_from_file(tmp));
	free(tmp);
	gtk_box_pack_start(GTK_BOX(typebox2), psychicb, TRUE, TRUE, 0);
	fungusb = gtk_toggle_button_new();
	tmp = gm_pixmap_file("gm-fungus.xpm");
	gtk_container_add(GTK_CONTAINER(fungusb), gnome_pixmap_new_from_file(tmp));
	free(tmp);
	gtk_box_pack_start(GTK_BOX(typebox2), fungusb, TRUE, TRUE, 0);
	nocturnalb = gtk_toggle_button_new();
	tmp = gm_pixmap_file("gm-nocturnal.xpm");
	gtk_container_add(GTK_CONTAINER(nocturnalb), gnome_pixmap_new_from_file(tmp));
	free(tmp);
	gtk_box_pack_start(GTK_BOX(typebox2), nocturnalb, TRUE, TRUE, 0);
	cyberneticb = gtk_toggle_button_new();
	tmp = gm_pixmap_file("gm-cybernetic.xpm");
	gtk_container_add(GTK_CONTAINER(cyberneticb), gnome_pixmap_new_from_file(tmp));
	free(tmp);
	gtk_box_pack_start(GTK_BOX(typebox2), cyberneticb, TRUE, TRUE, 0);
	iceb = gtk_toggle_button_new();
	tmp = gm_pixmap_file("gm-ice.xpm");
	gtk_container_add(GTK_CONTAINER(iceb), gnome_pixmap_new_from_file(tmp));
	free(tmp);
	gtk_box_pack_start(GTK_BOX(typebox2), iceb, TRUE, TRUE, 0);
	energyb = gtk_toggle_button_new();
	tmp = gm_pixmap_file("gm-energy.xpm");
	gtk_container_add(GTK_CONTAINER(energyb), gnome_pixmap_new_from_file(tmp));
	free(tmp);
	gtk_box_pack_start(GTK_BOX(typebox2), energyb, TRUE, TRUE, 0);
	ghostb = gtk_toggle_button_new();
	tmp = gm_pixmap_file("gm-ghost.xpm");
	gtk_container_add(GTK_CONTAINER(ghostb), gnome_pixmap_new_from_file(tmp));
	free(tmp);
	gtk_box_pack_start(GTK_BOX(typebox2), ghostb, TRUE, TRUE, 0);
	gtk_widget_set_sensitive(stoneb, FALSE);
	gtk_widget_set_sensitive(flyingb, FALSE);
	gtk_widget_set_sensitive(electricb, FALSE);
	gtk_widget_set_sensitive(waterb, FALSE);
	gtk_widget_set_sensitive(fireb, FALSE);
	gtk_widget_set_sensitive(poisonb, FALSE);
	gtk_widget_set_sensitive(insectb, FALSE);
	gtk_widget_set_sensitive(plantb, FALSE);
	gtk_widget_set_sensitive(fightingb, FALSE);
	gtk_widget_set_sensitive(psychicb, FALSE);
	gtk_widget_set_sensitive(fungusb, FALSE);
	gtk_widget_set_sensitive(nocturnalb, FALSE);
	gtk_widget_set_sensitive(cyberneticb, FALSE);
	gtk_widget_set_sensitive(iceb, FALSE);
	gtk_widget_set_sensitive(energyb, FALSE);
	gtk_widget_set_sensitive(ghostb, FALSE);
	areabox = gtk_hbox_new(TRUE, 0);
	plainsb = gtk_toggle_button_new_with_label("Plains");
	gtk_box_pack_start(GTK_BOX(areabox), plainsb, TRUE, TRUE, 0);
	forestb = gtk_toggle_button_new_with_label("Forest");
	gtk_box_pack_start(GTK_BOX(areabox), forestb, TRUE, TRUE, 0);
	cavesb = gtk_toggle_button_new_with_label("Caves");
	gtk_box_pack_start(GTK_BOX(areabox), cavesb, TRUE, TRUE, 0);
	mountainsb = gtk_toggle_button_new_with_label("Mountains");
	gtk_box_pack_start(GTK_BOX(areabox), mountainsb, TRUE, TRUE, 0);
	oceansb = gtk_toggle_button_new_with_label("Oceans");
	gtk_box_pack_start(GTK_BOX(areabox), oceansb, TRUE, TRUE, 0);
	riversb = gtk_toggle_button_new_with_label("Rivers");
	gtk_box_pack_start(GTK_BOX(areabox), riversb, TRUE, TRUE, 0);
	gtk_widget_set_sensitive(plainsb, FALSE);
	gtk_widget_set_sensitive(forestb, FALSE);
	gtk_widget_set_sensitive(cavesb, FALSE);
	gtk_widget_set_sensitive(mountainsb, FALSE);
	gtk_widget_set_sensitive(oceansb, FALSE);
	gtk_widget_set_sensitive(riversb, FALSE);
	aframe = gtk_frame_new("Abilities");
	avbox = gtk_vbox_new(FALSE, 0);
	alist = gtk_clist_new_with_titles(2, atitles);
	alscr = gtk_vscrollbar_new(0);
	gtk_clist_set_vadjustment(GTK_CLIST(alist), gtk_range_get_adjustment(GTK_RANGE(alscr)));
	ahbox = gtk_hbox_new(FALSE, 0);
	ashbox = gtk_hbox_new(FALSE, 0);
	abhbox = gtk_hbox_new(FALSE, 0);
	alevel = gtk_spin_button_new(GTK_ADJUSTMENT(gtk_adjustment_new(0, 0, 99, 1, 1, 1)), 1, 0);
	/*
	 * aability = gtk_option_menu_new(); { GtkWidget *amenu = gtk_menu_new();
	 * guint a; for(a = 0; a < gm_ability_list_length(); a++) { GtkWidget
	 * *amenuitem =
	 * gtk_menu_item_new_with_label(gm_ability_get_list()[a].name);
	 * gtk_menu_append(GTK_MENU(amenu), amenuitem); }
	 * gtk_option_menu_set_menu(GTK_OPTION_MENU(aability), amenu); }
	 */
	aability = gtk_entry_new();
	aadd = gnome_pixmap_button(gnome_stock_pixmap_widget(window, GNOME_STOCK_PIXMAP_ADD), "Add");
	aremove = gnome_pixmap_button(gnome_stock_pixmap_widget(window, GNOME_STOCK_PIXMAP_ADD), "Remove");
	gtk_widget_set_sensitive(alevel, FALSE);
	gtk_widget_set_sensitive(aability, FALSE);
	gtk_widget_set_sensitive(aadd, FALSE);
	gtk_widget_set_sensitive(aremove, FALSE);
	gtk_widget_set_usize(alist, 150, 1);
	gtk_container_add(GTK_CONTAINER(frame), fhbox);
	gtk_box_pack_start(GTK_BOX(hbox), ok, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), save, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), cancel, TRUE, FALSE, 0);
	gtk_packer_add(GTK_PACKER(packer), hbox, GTK_SIDE_BOTTOM, GTK_ANCHOR_CENTER, 0, 0, 0, 0, 0, 0);
	gtk_packer_add(GTK_PACKER(packer), svbox, GTK_SIDE_LEFT, GTK_ANCHOR_NORTH, GTK_FILL_X | GTK_FILL_Y | GTK_EXPAND, 0, 0, 0, 0, 0);
	gtk_box_pack_start(GTK_BOX(svbox), shbox, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(shbox), slist, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(shbox), slscr, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(svbox), bhbox, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(bhbox), news, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(bhbox), deletes, TRUE, TRUE, 0);
	gtk_packer_add(GTK_PACKER(packer), frame, GTK_SIDE_RIGHT, GTK_ANCHOR_NORTH, GTK_FILL_X | GTK_FILL_Y | GTK_EXPAND, 0, 0, 0, 0, 0);
	gtk_box_pack_start(GTK_BOX(fhbox), fvbox, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(fhbox), avbox, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(avbox), ahbox, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(ahbox), alist, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(ahbox), alscr, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(avbox), ashbox, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(avbox), abhbox, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(ashbox), alevel, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(ashbox), aability, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(abhbox), aadd, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(abhbox), aremove, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(fvbox), typebox, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(fvbox), typebox2, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(fvbox), areabox, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(fvbox), name, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(fvbox), desc, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(fvbox), hphbox, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(hphbox), hplabel, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(hphbox), hpup, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(hphbox), hpdown, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(fvbox), strhbox, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(strhbox), strlabel, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(strhbox), strup, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(strhbox), strdown, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(fvbox), defhbox, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(defhbox), deflabel, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(defhbox), defup, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(defhbox), defdown, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(fvbox), spdhbox, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(spdhbox), spdlabel, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(spdhbox), spdup, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(spdhbox), spddown, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(fvbox), inthbox, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(inthbox), intlabel, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(inthbox), intup, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(inthbox), intdown, FALSE, FALSE, 0);
	gnome_app_set_contents(GNOME_APP(window), packer);
	gtk_signal_connect(GTK_OBJECT(window), "destroy", GTK_SIGNAL_FUNC(&gtk_main_quit), NULL);
	gtk_signal_connect(GTK_OBJECT(cancel), "clicked", GTK_SIGNAL_FUNC(&gtk_main_quit), NULL);
	gtk_signal_connect(GTK_OBJECT(save), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_save), NULL);
	gtk_signal_connect(GTK_OBJECT(ok), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_quit), NULL);
	gtk_signal_connect(GTK_OBJECT(slist), "select_row", GTK_SIGNAL_FUNC(&gm_specedit_select), NULL);
	gtk_signal_connect(GTK_OBJECT(name), "activate", GTK_SIGNAL_FUNC(&gm_specedit_name_change), NULL);
	gtk_signal_connect(GTK_OBJECT(desc), "activate", GTK_SIGNAL_FUNC(&gm_specedit_desc_change), NULL);
	gtk_signal_connect(GTK_OBJECT(hpup), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_hp_up), NULL);
	gtk_signal_connect(GTK_OBJECT(hpdown), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_hp_down), NULL);
	gtk_signal_connect(GTK_OBJECT(strup), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_str_up), NULL);
	gtk_signal_connect(GTK_OBJECT(strdown), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_str_down), NULL);
	gtk_signal_connect(GTK_OBJECT(defup), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_def_up), NULL);
	gtk_signal_connect(GTK_OBJECT(defdown), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_def_down), NULL);
	gtk_signal_connect(GTK_OBJECT(spdup), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_spd_up), NULL);
	gtk_signal_connect(GTK_OBJECT(spddown), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_spd_down), NULL);
	gtk_signal_connect(GTK_OBJECT(intup), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_int_up), NULL);
	gtk_signal_connect(GTK_OBJECT(intdown), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_int_down), NULL);
	gtk_signal_connect(GTK_OBJECT(stoneb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_stone), NULL);
	gtk_signal_connect(GTK_OBJECT(flyingb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_flying), NULL);
	gtk_signal_connect(GTK_OBJECT(electricb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_electric), NULL);
	gtk_signal_connect(GTK_OBJECT(waterb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_water), NULL);
	gtk_signal_connect(GTK_OBJECT(fireb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_fire), NULL);
	gtk_signal_connect(GTK_OBJECT(poisonb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_poison), NULL);
	gtk_signal_connect(GTK_OBJECT(insectb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_insect), NULL);
	gtk_signal_connect(GTK_OBJECT(plantb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_plant), NULL);
	gtk_signal_connect(GTK_OBJECT(fightingb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_fighting), NULL);
	gtk_signal_connect(GTK_OBJECT(psychicb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_psychic), NULL);
	gtk_signal_connect(GTK_OBJECT(fungusb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_fungus), NULL);
	gtk_signal_connect(GTK_OBJECT(nocturnalb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_nocturnal), NULL);
	gtk_signal_connect(GTK_OBJECT(cyberneticb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_cybernetic), NULL);
	gtk_signal_connect(GTK_OBJECT(iceb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_ice), NULL);
	gtk_signal_connect(GTK_OBJECT(energyb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_energy), NULL);
	gtk_signal_connect(GTK_OBJECT(ghostb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_ghost), NULL);
	gtk_signal_connect(GTK_OBJECT(plainsb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_plains), NULL);
	gtk_signal_connect(GTK_OBJECT(forestb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_forest), NULL);
	gtk_signal_connect(GTK_OBJECT(cavesb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_caves), NULL);
	gtk_signal_connect(GTK_OBJECT(mountainsb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_mountains), NULL);
	gtk_signal_connect(GTK_OBJECT(oceansb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_oceans), NULL);
	gtk_signal_connect(GTK_OBJECT(riversb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_rivers), NULL);
	gtk_signal_connect(GTK_OBJECT(news), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_new), NULL);
	gtk_signal_connect(GTK_OBJECT(deletes), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_delete), NULL);
	gtk_signal_connect(GTK_OBJECT(alist), "select_row", GTK_SIGNAL_FUNC(&gm_specedit_ability_select), NULL);
	gtk_signal_connect(GTK_OBJECT(aadd), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_ability_add), NULL);
	gtk_signal_connect(GTK_OBJECT(aremove), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_ability_remove), NULL);
	gtk_widget_show_all(window);
	gtk_main();
	return 0;
}

void
gm_specedit_select(GtkWidget * widg, guint row, guint column)
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), row);
	guint a;
	selected = row;
	gtk_entry_set_text(GTK_ENTRY(name), spec->name);
	gtk_entry_set_text(GTK_ENTRY(desc), spec->desc);
	gtk_widget_set_sensitive(name, TRUE);
	gtk_widget_set_sensitive(desc, TRUE);
	if (spec->shp + spec->sstr + spec->sdef + spec->sspd + spec->swis < 15)
		gtk_widget_set_sensitive(hpup, TRUE);
	else
		gtk_widget_set_sensitive(hpup, FALSE);
	if (spec->shp > 0)
		gtk_widget_set_sensitive(hpdown, TRUE);
	else
		gtk_widget_set_sensitive(hpdown, FALSE);
	if (spec->shp + spec->sstr + spec->sdef + spec->sspd + spec->swis < 15)
		gtk_widget_set_sensitive(strup, TRUE);
	else
		gtk_widget_set_sensitive(strup, FALSE);
	if (spec->sstr > 0)
		gtk_widget_set_sensitive(strdown, TRUE);
	else
		gtk_widget_set_sensitive(strdown, FALSE);
	if (spec->shp + spec->sstr + spec->sdef + spec->sspd + spec->swis < 15)
		gtk_widget_set_sensitive(defup, TRUE);
	else
		gtk_widget_set_sensitive(defup, FALSE);
	if (spec->sdef > 0)
		gtk_widget_set_sensitive(defdown, TRUE);
	else
		gtk_widget_set_sensitive(defdown, FALSE);
	if (spec->shp + spec->sstr + spec->sdef + spec->sspd + spec->swis < 15)
		gtk_widget_set_sensitive(spdup, TRUE);
	else
		gtk_widget_set_sensitive(spdup, FALSE);
	if (spec->sspd > 0)
		gtk_widget_set_sensitive(spddown, TRUE);
	else
		gtk_widget_set_sensitive(spddown, FALSE);
	if (spec->shp + spec->sstr + spec->sdef + spec->sspd + spec->swis < 15)
		gtk_widget_set_sensitive(intup, TRUE);
	else
		gtk_widget_set_sensitive(intup, FALSE);
	if (spec->swis > 0)
		gtk_widget_set_sensitive(intdown, TRUE);
	else
		gtk_widget_set_sensitive(intdown, FALSE);
	infostr = g_strdup_printf("Health: %u", spec->shp);
	gtk_label_set_text(GTK_LABEL(hplabel), infostr);
	free(infostr);
	infostr = g_strdup_printf("Strength: %u", spec->sstr);
	gtk_label_set_text(GTK_LABEL(strlabel), infostr);
	free(infostr);
	infostr = g_strdup_printf("Defense: %u", spec->sdef);
	gtk_label_set_text(GTK_LABEL(deflabel), infostr);
	free(infostr);
	infostr = g_strdup_printf("Speed: %u", spec->sspd);
	gtk_label_set_text(GTK_LABEL(spdlabel), infostr);
	free(infostr);
	infostr = g_strdup_printf("Intelligence: %u", spec->swis);
	gtk_label_set_text(GTK_LABEL(intlabel), infostr);
	free(infostr);
	gtk_clist_clear(GTK_CLIST(alist));
	for (a = 0; a < spec->alistlen; a++) {
		gchar *names[2] = { g_strdup_printf("%u", spec->alist[a]->level),
			spec->alist[a]->ability
		};
		guint b;
		b = gtk_clist_append(GTK_CLIST(alist), names);
		gtk_clist_set_row_data(GTK_CLIST(alist), b, spec->alist[a]);
		free(names[0]);
	}
	gtk_signal_disconnect_by_func(GTK_OBJECT(stoneb), GTK_SIGNAL_FUNC(&gm_specedit_stone), NULL);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(stoneb), (spec->type & GM_STONE ? TRUE : FALSE));
	gtk_widget_set_sensitive(stoneb, TRUE);
	gtk_signal_connect(GTK_OBJECT(stoneb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_stone), NULL);
	gtk_signal_disconnect_by_func(GTK_OBJECT(flyingb), GTK_SIGNAL_FUNC(&gm_specedit_flying), NULL);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(flyingb), (spec->type & GM_FLYING ? TRUE : FALSE));
	gtk_widget_set_sensitive(flyingb, TRUE);
	gtk_signal_connect(GTK_OBJECT(flyingb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_flying), NULL);
	gtk_signal_disconnect_by_func(GTK_OBJECT(electricb), GTK_SIGNAL_FUNC(&gm_specedit_electric), NULL);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(electricb), (spec->type & GM_ELECTRIC ? TRUE : FALSE));
	gtk_widget_set_sensitive(electricb, TRUE);
	gtk_signal_connect(GTK_OBJECT(electricb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_electric), NULL);
	gtk_signal_disconnect_by_func(GTK_OBJECT(waterb), GTK_SIGNAL_FUNC(&gm_specedit_water), NULL);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(waterb), (spec->type & GM_WATER ? TRUE : FALSE));
	gtk_widget_set_sensitive(waterb, TRUE);
	gtk_signal_connect(GTK_OBJECT(waterb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_water), NULL);
	gtk_signal_disconnect_by_func(GTK_OBJECT(fireb), GTK_SIGNAL_FUNC(&gm_specedit_fire), NULL);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(fireb), (spec->type & GM_FIRE ? TRUE : FALSE));
	gtk_widget_set_sensitive(fireb, TRUE);
	gtk_signal_connect(GTK_OBJECT(fireb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_fire), NULL);
	gtk_signal_disconnect_by_func(GTK_OBJECT(poisonb), GTK_SIGNAL_FUNC(&gm_specedit_poison), NULL);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(poisonb), (spec->type & GM_POISON ? TRUE : FALSE));
	gtk_widget_set_sensitive(poisonb, TRUE);
	gtk_signal_connect(GTK_OBJECT(poisonb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_poison), NULL);
	gtk_signal_disconnect_by_func(GTK_OBJECT(insectb), GTK_SIGNAL_FUNC(&gm_specedit_insect), NULL);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(insectb), (spec->type & GM_INSECT ? TRUE : FALSE));
	gtk_widget_set_sensitive(insectb, TRUE);
	gtk_signal_connect(GTK_OBJECT(insectb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_insect), NULL);
	gtk_signal_disconnect_by_func(GTK_OBJECT(plantb), GTK_SIGNAL_FUNC(&gm_specedit_plant), NULL);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(plantb), (spec->type & GM_PLANT ? TRUE : FALSE));
	gtk_widget_set_sensitive(plantb, TRUE);
	gtk_signal_connect(GTK_OBJECT(plantb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_plant), NULL);
	gtk_signal_disconnect_by_func(GTK_OBJECT(fightingb), GTK_SIGNAL_FUNC(&gm_specedit_fighting), NULL);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(fightingb), (spec->type & GM_FIGHTING ? TRUE : FALSE));
	gtk_widget_set_sensitive(fightingb, TRUE);
	gtk_signal_connect(GTK_OBJECT(fightingb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_fighting), NULL);
	gtk_signal_disconnect_by_func(GTK_OBJECT(psychicb), GTK_SIGNAL_FUNC(&gm_specedit_psychic), NULL);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(psychicb), (spec->type & GM_PSYCHIC ? TRUE : FALSE));
	gtk_widget_set_sensitive(psychicb, TRUE);
	gtk_signal_connect(GTK_OBJECT(psychicb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_psychic), NULL);
	gtk_signal_disconnect_by_func(GTK_OBJECT(fungusb), GTK_SIGNAL_FUNC(&gm_specedit_fungus), NULL);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(fungusb), (spec->type & GM_FUNGUS ? TRUE : FALSE));
	gtk_widget_set_sensitive(fungusb, TRUE);
	gtk_signal_connect(GTK_OBJECT(fungusb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_fungus), NULL);
	gtk_signal_disconnect_by_func(GTK_OBJECT(nocturnalb), GTK_SIGNAL_FUNC(&gm_specedit_nocturnal), NULL);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(nocturnalb), (spec->type & GM_NOCTURNAL ? TRUE : FALSE));
	gtk_widget_set_sensitive(nocturnalb, TRUE);
	gtk_signal_connect(GTK_OBJECT(nocturnalb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_nocturnal), NULL);
	gtk_signal_disconnect_by_func(GTK_OBJECT(cyberneticb), GTK_SIGNAL_FUNC(&gm_specedit_cybernetic), NULL);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(cyberneticb), (spec->type & GM_CYBERNETIC ? TRUE : FALSE));
	gtk_widget_set_sensitive(cyberneticb, TRUE);
	gtk_signal_connect(GTK_OBJECT(cyberneticb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_cybernetic), NULL);
	gtk_signal_disconnect_by_func(GTK_OBJECT(iceb), GTK_SIGNAL_FUNC(&gm_specedit_ice), NULL);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(iceb), (spec->type & GM_ICE ? TRUE : FALSE));
	gtk_widget_set_sensitive(iceb, TRUE);
	gtk_signal_connect(GTK_OBJECT(iceb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_ice), NULL);
	gtk_signal_disconnect_by_func(GTK_OBJECT(energyb), GTK_SIGNAL_FUNC(&gm_specedit_energy), NULL);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(energyb), (spec->type & GM_ENERGY ? TRUE : FALSE));
	gtk_widget_set_sensitive(energyb, TRUE);
	gtk_signal_connect(GTK_OBJECT(energyb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_energy), NULL);
	gtk_signal_disconnect_by_func(GTK_OBJECT(ghostb), GTK_SIGNAL_FUNC(&gm_specedit_ghost), NULL);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ghostb), (spec->type & GM_GHOST ? TRUE : FALSE));
	gtk_widget_set_sensitive(ghostb, TRUE);
	gtk_signal_connect(GTK_OBJECT(ghostb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_ghost), NULL);
	gtk_widget_set_sensitive(deletes, TRUE);
	gtk_widget_set_sensitive(alevel, TRUE);
	gtk_widget_set_sensitive(aability, TRUE);
	gtk_widget_set_sensitive(aadd, TRUE);
	gtk_widget_set_sensitive(aremove, FALSE);
	gtk_signal_disconnect_by_func(GTK_OBJECT(plainsb), GTK_SIGNAL_FUNC(&gm_specedit_plains), NULL);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(plainsb), (spec->areas & GM_PLAINS ? TRUE : FALSE));
	gtk_widget_set_sensitive(plainsb, TRUE);
	gtk_signal_connect(GTK_OBJECT(plainsb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_plains), NULL);
	gtk_signal_disconnect_by_func(GTK_OBJECT(forestb), GTK_SIGNAL_FUNC(&gm_specedit_forest), NULL);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(forestb), (spec->areas & GM_FOREST ? TRUE : FALSE));
	gtk_widget_set_sensitive(forestb, TRUE);
	gtk_signal_connect(GTK_OBJECT(forestb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_forest), NULL);
	gtk_signal_disconnect_by_func(GTK_OBJECT(cavesb), GTK_SIGNAL_FUNC(&gm_specedit_caves), NULL);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(cavesb), (spec->areas & GM_CAVES ? TRUE : FALSE));
	gtk_widget_set_sensitive(cavesb, TRUE);
	gtk_signal_connect(GTK_OBJECT(cavesb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_caves), NULL);
	gtk_signal_disconnect_by_func(GTK_OBJECT(mountainsb), GTK_SIGNAL_FUNC(&gm_specedit_mountains), NULL);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(mountainsb), (spec->areas & GM_MOUNTAINS ? TRUE : FALSE));
	gtk_widget_set_sensitive(mountainsb, TRUE);
	gtk_signal_connect(GTK_OBJECT(mountainsb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_mountains), NULL);
	gtk_signal_disconnect_by_func(GTK_OBJECT(oceansb), GTK_SIGNAL_FUNC(&gm_specedit_oceans), NULL);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(oceansb), (spec->areas & GM_OCEANS ? TRUE : FALSE));
	gtk_widget_set_sensitive(oceansb, TRUE);
	gtk_signal_connect(GTK_OBJECT(oceansb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_oceans), NULL);
	gtk_signal_disconnect_by_func(GTK_OBJECT(riversb), GTK_SIGNAL_FUNC(&gm_specedit_rivers), NULL);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(riversb), (spec->areas & GM_RIVERS ? TRUE : FALSE));
	gtk_widget_set_sensitive(riversb, TRUE);
	gtk_signal_connect(GTK_OBJECT(riversb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_rivers), NULL);
}

void
gm_specedit_name_change()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	free(spec->name);
	spec->name = g_strdup(gtk_entry_get_text(GTK_ENTRY(name)));
	gtk_clist_set_text(GTK_CLIST(slist), selected, 1, spec->name);
	gm_specedit_select(slist, selected, 0);
}

void
gm_specedit_desc_change()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	free(spec->desc);
	spec->desc = g_strdup(gtk_entry_get_text(GTK_ENTRY(desc)));
	gm_specedit_select(slist, selected, 0);
}

void
gm_specedit_quit()
{
	gm_specedit_save();
	gtk_main_quit();
}

void
gm_specedit_save()
{
	gchar *speciesfile = gm_data_file("gmspecies");
	FILE *fp = fopen(speciesfile, "w");
	guint a, b;
	if (fp != NULL) {
		fwrite(&GTK_CLIST(slist)->rows, sizeof(guint), 1, fp);
		for (a = 0; a < GTK_CLIST(slist)->rows; a++) {
			GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist),
																   a);
			guint len = strlen(spec->name) + 1;
			fwrite(&len, sizeof(guint), 1, fp);
			fwrite(spec->name, sizeof(gchar), len, fp);
			len = strlen(spec->desc) + 1;
			fwrite(&len, sizeof(guint), 1, fp);
			fwrite(spec->desc, sizeof(gchar), len, fp);
			spec->type = spec->type & (GM_STONE | GM_FLYING | GM_ELECTRIC | GM_WATER | GM_FIRE | GM_POISON | GM_INSECT | GM_PLANT | GM_FIGHTING | GM_PSYCHIC | GM_FUNGUS | GM_NOCTURNAL | GM_CYBERNETIC | GM_ICE | GM_ENERGY | GM_GHOST);
			fwrite(&spec->type, sizeof(GMClassification), 1, fp);
			fwrite(&spec->shp, sizeof(guint), 1, fp);
			fwrite(&spec->sstr, sizeof(guint), 1, fp);
			fwrite(&spec->sdef, sizeof(guint), 1, fp);
			fwrite(&spec->sspd, sizeof(guint), 1, fp);
			fwrite(&spec->swis, sizeof(guint), 1, fp);
			spec->areas = spec->areas & (GM_PLAINS | GM_FOREST | GM_CAVES | GM_MOUNTAINS | GM_OCEANS | GM_RIVERS);
			fwrite(&spec->areas, sizeof(GMAreas), 1, fp);
			fwrite(&spec->alistlen, sizeof(guint), 1, fp);
			for (b = 0; b < spec->alistlen; b++) {
				fwrite(&spec->alist[b]->level, sizeof(guint), 1, fp);
				len = strlen(spec->alist[b]->ability) + 1;
				fwrite(&len, sizeof(guint), 1, fp);
				fwrite(spec->alist[b]->ability, sizeof(gchar), len, fp);
			}
		}
		fclose(fp);
	}
	fp = fopen("/tmp/species.html", "w");
	fprintf(fp, "<html>\n<title>GMonsters Species List</title>\n");
	for (a = 0; a < GTK_CLIST(slist)->rows; a++) {
		GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), a);
		fprintf(fp,
				"<b>Name:</b> %s<br>\n<b>Types:</b>%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s<br>\n<b>Health Growth:</b> %u<br>\n<b>Strength Growth:</b> %u<br>\n<b>Defense Growth:</b> %u<br>\n<b>Speed Growth:</b> %u<br>\n<b>Intelligence Growth:</b> %u<br>\n<b>Description:</b>\n%s<br>\n<b>Abilities (Level - Name):</b><br>\n",
				spec->name, (spec->type & GM_STONE ? " Stone" : ""), (spec->type & GM_FLYING ? " Flying" : ""), (spec->type & GM_ELECTRIC ? " Electric" : ""), (spec->type & GM_WATER ? " Water" : ""), (spec->type & GM_FIRE ? " Fire" : ""), (spec->type & GM_POISON ? " Poison" : ""), (spec->type & GM_INSECT ? " Insect" : ""), (spec->type & GM_PLANT ? " Plant" : ""), (spec->type & GM_FIGHTING ? " Fighting" : ""), (spec->type & GM_PSYCHIC ? " Psychic" : ""), (spec->type & GM_FUNGUS ? " Fungus" : ""), (spec->type & GM_NOCTURNAL ? " Nocturnal" : ""), (spec->type & GM_CYBERNETIC ? " Cybernetic" : ""), (spec->type & GM_ICE ? " Ice" : ""), (spec->type & GM_ENERGY ? " Energy" : ""), (spec->type & GM_GHOST ? " Ghost" : ""), spec->shp, spec->sstr, spec->sdef, spec->sspd, spec->swis, spec->desc);
		fprintf(fp, "<ul>\n");
		for (b = 0; b < spec->alistlen; b++)
			fprintf(fp, "<li>%u - %s</li>\n", spec->alist[b]->level, spec->alist[b]->ability);
		fprintf(fp, "</ul>\n");
	}
	fprintf(fp, "</html>\n");
	fclose(fp);
	free(speciesfile);
}

void
gm_specedit_hp_up()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	spec->shp++;
	gm_specedit_select(slist, selected, 0);
}

void
gm_specedit_hp_down()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	spec->shp--;
	gm_specedit_select(slist, selected, 0);
}

void
gm_specedit_str_up()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	spec->sstr++;
	gm_specedit_select(slist, selected, 0);
}

void
gm_specedit_str_down()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	spec->sstr--;
	gm_specedit_select(slist, selected, 0);
}

void
gm_specedit_def_up()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	spec->sdef++;
	gm_specedit_select(slist, selected, 0);
}

void
gm_specedit_def_down()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	spec->sdef--;
	gm_specedit_select(slist, selected, 0);
}

void
gm_specedit_spd_up()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	spec->sspd++;
	gm_specedit_select(slist, selected, 0);
}

void
gm_specedit_spd_down()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	spec->sspd--;
	gm_specedit_select(slist, selected, 0);
}

void
gm_specedit_int_up()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	spec->swis++;
	gm_specedit_select(slist, selected, 0);
}

void
gm_specedit_int_down()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	spec->swis--;
	gm_specedit_select(slist, selected, 0);
}

void
gm_specedit_stone()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	if (spec->type & GM_STONE)
		spec->type -= GM_STONE;
	else
		spec->type += GM_STONE;
}

void
gm_specedit_flying()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	if (spec->type & GM_FLYING)
		spec->type -= GM_FLYING;
	else
		spec->type += GM_FLYING;
}

void
gm_specedit_electric()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	if (spec->type & GM_ELECTRIC)
		spec->type -= GM_ELECTRIC;
	else
		spec->type += GM_ELECTRIC;
}

void
gm_specedit_water()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	if (spec->type & GM_WATER)
		spec->type -= GM_WATER;
	else
		spec->type += GM_WATER;
}

void
gm_specedit_fire()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	if (spec->type & GM_FIRE)
		spec->type -= GM_FIRE;
	else
		spec->type += GM_FIRE;
}

void
gm_specedit_poison()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	if (spec->type & GM_POISON)
		spec->type -= GM_POISON;
	else
		spec->type += GM_POISON;
}

void
gm_specedit_insect()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	if (spec->type & GM_INSECT)
		spec->type -= GM_INSECT;
	else
		spec->type += GM_INSECT;
}

void
gm_specedit_plant()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	if (spec->type & GM_PLANT)
		spec->type -= GM_PLANT;
	else
		spec->type += GM_PLANT;
}

void
gm_specedit_fighting()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	if (spec->type & GM_FIGHTING)
		spec->type -= GM_FIGHTING;
	else
		spec->type += GM_FIGHTING;
}

void
gm_specedit_psychic()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	if (spec->type & GM_PSYCHIC)
		spec->type -= GM_PSYCHIC;
	else
		spec->type += GM_PSYCHIC;
}

void
gm_specedit_fungus()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	if (spec->type & GM_FUNGUS)
		spec->type -= GM_FUNGUS;
	else
		spec->type += GM_FUNGUS;
}

void
gm_specedit_nocturnal()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	if (spec->type & GM_NOCTURNAL)
		spec->type -= GM_NOCTURNAL;
	else
		spec->type += GM_NOCTURNAL;
}

void
gm_specedit_cybernetic()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	if (spec->type & GM_CYBERNETIC)
		spec->type -= GM_CYBERNETIC;
	else
		spec->type += GM_CYBERNETIC;
}

void
gm_specedit_ice()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	if (spec->type & GM_ICE)
		spec->type -= GM_ICE;
	else
		spec->type += GM_ICE;
}

void
gm_specedit_energy()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	if (spec->type & GM_ENERGY)
		spec->type -= GM_ENERGY;
	else
		spec->type += GM_ENERGY;
}

void
gm_specedit_ghost()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	if (spec->type & GM_GHOST)
		spec->type -= GM_GHOST;
	else
		spec->type += GM_GHOST;
}

void
gm_specedit_plains()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	if (spec->areas & GM_PLAINS)
		spec->areas -= GM_PLAINS;
	else
		spec->areas += GM_PLAINS;
}

void
gm_specedit_forest()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	if (spec->areas & GM_FOREST)
		spec->areas -= GM_FOREST;
	else
		spec->areas += GM_FOREST;
}

void
gm_specedit_caves()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	if (spec->areas & GM_CAVES)
		spec->areas -= GM_CAVES;
	else
		spec->areas += GM_CAVES;
}

void
gm_specedit_mountains()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	if (spec->areas & GM_MOUNTAINS)
		spec->areas -= GM_MOUNTAINS;
	else
		spec->areas += GM_MOUNTAINS;
}

void
gm_specedit_oceans()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	if (spec->areas & GM_OCEANS)
		spec->areas -= GM_OCEANS;
	else
		spec->areas += GM_OCEANS;
}

void
gm_specedit_rivers()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	if (spec->areas & GM_RIVERS)
		spec->areas -= GM_RIVERS;
	else
		spec->areas += GM_RIVERS;
}

void
gm_specedit_new()
{
	gchar *names[1] = { "New Species" };
	guint a;
	GMSpecies *spec = malloc(sizeof(GMSpecies));
	spec->name = g_strdup("New Species");
	spec->desc = g_strdup("New species created by GMonsters Species Editor.");
	spec->type = 0;
	spec->shp = 0;
	spec->sstr = 0;
	spec->sdef = 0;
	spec->sspd = 0;
	spec->swis = 0;
	spec->alistlen = 1;
	spec->alist = malloc(sizeof(GMLearnAbility *));
	spec->alist[0] = malloc(sizeof(GMLearnAbility));
	spec->alist[0]->level = 0;
	spec->alist[0]->ability = g_strdup("Tackle");
	a = gtk_clist_append(GTK_CLIST(slist), names);
	gtk_clist_set_row_data(GTK_CLIST(slist), a, spec);
}

void
gm_specedit_delete()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	gchar *strng = g_strdup_printf("Once you delete a species, you can't undo it.\nAre you sure you want to delete %s?",
								   spec->name);
	gboolean dele = FALSE;
	gnome_dialog_run(GNOME_DIALOG(gnome_app_question_modal(GNOME_APP(window), strng, &gm_specedit_really_delete, &dele)));
	if (dele == TRUE) {
		gtk_clist_remove(GTK_CLIST(slist), selected);
		selected = 0;
		gtk_entry_set_text(GTK_ENTRY(name), "");
		gtk_entry_set_text(GTK_ENTRY(desc), "");
		gtk_widget_set_sensitive(name, FALSE);
		gtk_widget_set_sensitive(desc, FALSE);
		gtk_widget_set_sensitive(hpup, FALSE);
		gtk_widget_set_sensitive(hpdown, FALSE);
		gtk_widget_set_sensitive(strup, FALSE);
		gtk_widget_set_sensitive(strdown, FALSE);
		gtk_widget_set_sensitive(defup, FALSE);
		gtk_widget_set_sensitive(defdown, FALSE);
		gtk_widget_set_sensitive(spdup, FALSE);
		gtk_widget_set_sensitive(spddown, FALSE);
		gtk_widget_set_sensitive(intup, FALSE);
		gtk_widget_set_sensitive(intdown, FALSE);
		gtk_label_set_text(GTK_LABEL(hplabel), "Health:");
		gtk_label_set_text(GTK_LABEL(strlabel), "Strength:");
		gtk_label_set_text(GTK_LABEL(deflabel), "Defense:");
		gtk_label_set_text(GTK_LABEL(spdlabel), "Speed:");
		gtk_label_set_text(GTK_LABEL(intlabel), "Intelligence:");
		gtk_clist_clear(GTK_CLIST(alist));
		gtk_signal_disconnect_by_func(GTK_OBJECT(stoneb), GTK_SIGNAL_FUNC(&gm_specedit_stone), NULL);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(stoneb), FALSE);
		gtk_widget_set_sensitive(stoneb, FALSE);
		gtk_signal_connect(GTK_OBJECT(stoneb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_stone), NULL);
		gtk_signal_disconnect_by_func(GTK_OBJECT(flyingb), GTK_SIGNAL_FUNC(&gm_specedit_flying), NULL);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(flyingb), FALSE);
		gtk_widget_set_sensitive(flyingb, FALSE);
		gtk_signal_connect(GTK_OBJECT(flyingb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_flying), NULL);
		gtk_signal_disconnect_by_func(GTK_OBJECT(electricb), GTK_SIGNAL_FUNC(&gm_specedit_electric), NULL);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(electricb), FALSE);
		gtk_widget_set_sensitive(electricb, FALSE);
		gtk_signal_connect(GTK_OBJECT(electricb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_electric), NULL);
		gtk_signal_disconnect_by_func(GTK_OBJECT(waterb), GTK_SIGNAL_FUNC(&gm_specedit_water), NULL);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(waterb), FALSE);
		gtk_widget_set_sensitive(waterb, FALSE);
		gtk_signal_connect(GTK_OBJECT(waterb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_water), NULL);
		gtk_signal_disconnect_by_func(GTK_OBJECT(fireb), GTK_SIGNAL_FUNC(&gm_specedit_fire), NULL);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(fireb), FALSE);
		gtk_widget_set_sensitive(fireb, FALSE);
		gtk_signal_connect(GTK_OBJECT(fireb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_fire), NULL);
		gtk_signal_disconnect_by_func(GTK_OBJECT(poisonb), GTK_SIGNAL_FUNC(&gm_specedit_poison), NULL);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(poisonb), FALSE);
		gtk_widget_set_sensitive(poisonb, FALSE);
		gtk_signal_connect(GTK_OBJECT(poisonb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_poison), NULL);
		gtk_signal_disconnect_by_func(GTK_OBJECT(insectb), GTK_SIGNAL_FUNC(&gm_specedit_insect), NULL);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(insectb), FALSE);
		gtk_widget_set_sensitive(insectb, FALSE);
		gtk_signal_connect(GTK_OBJECT(insectb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_insect), NULL);
		gtk_signal_disconnect_by_func(GTK_OBJECT(plantb), GTK_SIGNAL_FUNC(&gm_specedit_plant), NULL);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(plantb), FALSE);
		gtk_widget_set_sensitive(plantb, FALSE);
		gtk_signal_connect(GTK_OBJECT(plantb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_plant), NULL);
		gtk_signal_disconnect_by_func(GTK_OBJECT(fightingb), GTK_SIGNAL_FUNC(&gm_specedit_fighting), NULL);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(fightingb), FALSE);
		gtk_widget_set_sensitive(fightingb, FALSE);
		gtk_signal_connect(GTK_OBJECT(fightingb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_fighting), NULL);
		gtk_signal_disconnect_by_func(GTK_OBJECT(psychicb), GTK_SIGNAL_FUNC(&gm_specedit_psychic), NULL);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(psychicb), FALSE);
		gtk_widget_set_sensitive(psychicb, FALSE);
		gtk_signal_connect(GTK_OBJECT(psychicb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_psychic), NULL);
		gtk_signal_disconnect_by_func(GTK_OBJECT(fungusb), GTK_SIGNAL_FUNC(&gm_specedit_fungus), NULL);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(fungusb), FALSE);
		gtk_widget_set_sensitive(fungusb, FALSE);
		gtk_signal_connect(GTK_OBJECT(fungusb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_fungus), NULL);
		gtk_signal_disconnect_by_func(GTK_OBJECT(nocturnalb), GTK_SIGNAL_FUNC(&gm_specedit_nocturnal), NULL);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(nocturnalb), FALSE);
		gtk_widget_set_sensitive(nocturnalb, FALSE);
		gtk_signal_connect(GTK_OBJECT(nocturnalb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_nocturnal), NULL);
		gtk_signal_disconnect_by_func(GTK_OBJECT(cyberneticb), GTK_SIGNAL_FUNC(&gm_specedit_cybernetic), NULL);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(cyberneticb), FALSE);
		gtk_widget_set_sensitive(cyberneticb, FALSE);
		gtk_signal_connect(GTK_OBJECT(cyberneticb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_cybernetic), NULL);
		gtk_signal_disconnect_by_func(GTK_OBJECT(iceb), GTK_SIGNAL_FUNC(&gm_specedit_ice), NULL);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(iceb), FALSE);
		gtk_widget_set_sensitive(iceb, FALSE);
		gtk_signal_connect(GTK_OBJECT(iceb), "clicked", GTK_SIGNAL_FUNC(&gm_specedit_ice), NULL);
		gtk_widget_set_sensitive(deletes, FALSE);
		free(spec);
	}
	free(strng);
}

void
gm_specedit_really_delete(gint reply, gpointer data)
{
	gboolean *dele = (gboolean *) data;
	if (reply == GNOME_YES)
		*dele = TRUE;
}

void
gm_specedit_ability_select(GtkWidget * widg, guint row, guint column)
{
	aselected = row;
	gtk_widget_set_sensitive(aremove, TRUE);
}

void
gm_specedit_ability_add()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	gchar *names[2] = { g_strdup_printf("%u",
										gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(alevel))),
		gtk_entry_get_text(GTK_ENTRY(aability))
	};
	guint a;
	GMLearnAbility **tmp = spec->alist;
	gtk_clist_append(GTK_CLIST(alist), names);
	spec->alistlen++;
	spec->alist = malloc(sizeof(GMLearnAbility *) * spec->alistlen);
	for (a = 0; a < spec->alistlen - 1; a++)
		spec->alist[a] = tmp[a];
	spec->alist[spec->alistlen - 1] = malloc(sizeof(GMLearnAbility));
	spec->alist[spec->alistlen - 1]->level = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(alevel));
	spec->alist[spec->alistlen - 1]->ability = g_strdup(gtk_entry_get_text(GTK_ENTRY(aability)));
	free(names[0]);
	free(tmp);
}

void
gm_specedit_ability_remove()
{
	GMSpecies *spec = (GMSpecies *) gtk_clist_get_row_data(GTK_CLIST(slist), selected);
	guint a;
	GMLearnAbility **tmp = spec->alist;
	gtk_clist_remove(GTK_CLIST(alist), aselected);
	spec->alistlen--;
	spec->alist = malloc(sizeof(GMLearnAbility *) * spec->alistlen);
	for (a = 0; a < aselected; a++)
		spec->alist[a] = tmp[a];
	for (a = aselected + 1; a < spec->alistlen + 1; a++)
		spec->alist[a - 1] = tmp[a];
	free(tmp);
	aselected = 0;
	gtk_widget_set_sensitive(aremove, FALSE);
}
